<template>
  <div class="col-2 p-2">
    <input type="text" class="form-control input-group-sm" placeholder="Rechercher un utilisateur" v-model="searchValue">
  </div>
  <EasyDataTable
      buttons-pagination
      :headers="headers"
      :items="items"
      :loading="loading"
      theme-color="#216155"
      table-class-name="customize-table"
      :search-field="searchField"
      :search-value="searchValue"
  >

    <template #item-action="{item}">
      <button class="btn btn-light ml-2"> 
        <font-awesome-icon icon="fa-solid fa-trash-can" />
      </button>
    </template>

    <template #item-roles="{id,roles}">
      <div v-for="(role, key) in roles" :key="key" class="form-check form-check-inline">  
        <input @change="changeRole(id,key)" v-if="role" class="form-check-input" type="checkbox" :id="`${id}_${key}`" checked />
        <input @change="changeRole(id,key)" v-else class="form-check-input" type="checkbox" :id="`${id}_${key}`" />
        <label :for="`${id}_${key}`">{{key}}</label>
      </div>
    </template>
    <template #item-updated_at="{updated_at}" >
      <div v-if="(new Date() - updated_at) < 604800000">
        <font-awesome-icon icon="fa-solid fa-circle" class="active"  />
        <span>Actif</span>
      </div>
      <div v-else-if="(new Date() - updated_at) < 2629746000">
        <font-awesome-icon icon="fa-solid fa-circle" class="absent" />
        <span class="ms-1">Absent</span>
      </div>
      <div v-else>
        <font-awesome-icon icon="fa-solid fa-circle" class="inactive" />
        <span  class="ms-1">Inactif</span>
      </div>
    </template>
    <template #item-created_at="{created_at}" >
      {{ formatDate(created_at) }}
    </template>
  </EasyDataTable> 
</template>
<script lang="ts">
import { DateTime } from "luxon";
import { defineComponent } from "vue";
import { Header, Item,SortType } from "vue3-easy-data-table";
import { getUsers,putUserRoles } from '../../composition-api/administrations.api'
import { useMsal } from "../../composition-api/useMsal";
import { InteractionRequiredAuthError, InteractionStatus } from "@azure/msal-browser";
import { reactive, onMounted, watch ,ref} from 'vue'
import { loginRequest } from "../../authConfig";
import { callMsGraphLastCo } from "../../utils/MsGraphApiCall";
import UserInfo from "../../utils/UserInfo";

export default {
    setup(){
      
      const { instance, inProgress } = useMsal();
      const searchValue = ref("");
      const searchField = ['id','name'];
      const headers: Header[] = [
          { text: "Id", value: "id", sortable:true,width:50},  // set fixed to true
          { text: "Nom", value: "name", sortable:true},
          { text: "Email", value: "email",},
          { text: "Rôles", value: "roles",sortable:true},
          { text: "Statut",value: "updated_at"},
          { text: "Crée le", value: "created_at",sortable:true},
          { text: " ", value: "action"}
      ];
      const items: Item[] = ref([]);
      const loading = ref(true);

      async function getAllUsers() {
          const [error , data] = await getUsers();
          if (error) console.error(error);
          else {
              items.value = data
              loading.value = false //ajouter la photo user en bdd + updated_at pour voir les status 
          };
      }
      async function getGraphData(id:string) {
        const response = await instance.acquireTokenSilent({
          ...loginRequest
        }).catch(async (e) => {
          if (e instanceof InteractionRequiredAuthError) {
            await instance.acquireTokenRedirect(loginRequest);
          }
          throw e;
        });
        if (inProgress.value === InteractionStatus.None) {
          console.log(id,response.accessToken)
          const graphData = await callMsGraphLastCo(response.accessToken,id);
        return graphData;
      }
    }

      async function getLastAuth() {
          const users:any = items.value;
          let us:any = [];
          users.map(user => {
            const data = getGraphData(user.microsoft_id)
            console.log('data')
            us.push({
              ...user,

            })
          })
          const [error , data] = await getUsers();
          if (error) console.error(error);
          else {
              items.value = data
              loading.value = false //ajouter la photo user en bdd + updated_at pour voir les status 
          };
      }

      function formatDate(date:string){
        return DateTime.fromISO(date).toFormat('dd/mm/yyyy')
      }
      
      async function changeRole(id:any, role: number) {
        const [error , data] = await putUserRoles(id,role,event?.target?.checked);
          if (error) console.error(error);
          else{
            console.log(data)
          }
      }

      async function deleteUser(id:any) {
        const [error , data] = await deleteUser(id);
          if (error) console.error(error);
      }

      return {
        changeRole,
        deleteUser,
        formatDate,
        getAllUsers,
        getLastAuth,
        headers,
        items,
        loading,
        searchValue,
        searchField,
          
      }
    },
    async created(){
       await this.getAllUsers();
      // await this.getLastAuth();
        
    }
}
</script>

<style>
.fa-solid {
  margin-right: 5px;
}

.fa-circle {
  font-size: 14px;
  color: white;
}

.active {
  color: green;
}

.absent {
  color: yellow;
}

.inactive {
  color: red;
}
</style>